<template>
  <div v-loading="loading">
    <div class="heior_box">
      <el-button size="small" type="primary" icon="el-icon-sold-out" @click="showDialog=true">认领</el-button>
      <el-button size="small" type="primary" icon="el-icon-sold-out" @click="dataExport" v-if="$local.isRoot()">导出</el-button>
      <div class="search-box">
        <el-select v-model="searchModel.ProductId" placeholder="选择产品" clearable size="small">
          <el-option v-for="item in products" :key="item.Name" :label="item.Name" :value="item.Id"></el-option>
        </el-select>
        <el-select
          v-model="searchModel.OrderTypes"
          multiple
          collapse-tags
          clearable
          size="small"
          placeholder="选择类型"
        >
          <el-option v-for="item in types" :key="item.text" :label="item.text" :value="item.value"></el-option>
        </el-select>
        <el-date-picker
          size="small"
          v-model="dateRange"
          type="daterange"
          range-separator="至"
          start-placeholder="开始日期"
          end-placeholder="结束日期"
        ></el-date-picker>
        <el-input v-model="searchModel.keyWord" placeholder="请输入订单号、订单名称、用户名" clearable size="small">
          <el-button slot="append" icon="el-icon-search" @click="search"></el-button>
        </el-input>
      </div>
    </div>
    <el-table :data="retData.Data"  row-key="Id" border size="medium" :height="$getHeight(100)">
      <el-table-column prop="CreateTime" label="创建日期" ></el-table-column>
       <el-table-column prop="Channel" label="销售人" ></el-table-column>
      <el-table-column prop="OrderNo" label="订单号"></el-table-column>
      <el-table-column prop="OrderType" label="类型"   :formatter="typeFormat"></el-table-column>
      <el-table-column prop="UserName" label="用户" >
        <template slot-scope="scope"> 
          <phoneHide :text="scope.row.UserName"></phoneHide>
        </template>
      </el-table-column>
      <el-table-column prop="ProductName" label="产品"></el-table-column>
      <el-table-column prop="PackageName" label="套餐"></el-table-column>
      <el-table-column prop="DayPrice" label="单价"></el-table-column>
      <el-table-column prop="ConnectCount" label="连接数">
        <template slot-scope="scope">
          {{scope.row.ConnectCount*scope.row.AccountCount}}
        </template>
      </el-table-column>
      <el-table-column prop="Accounts" label="账号">
         <template slot-scope="scope">
          <cutTip :text="scope.row.Accounts"></cutTip>
        </template>
      </el-table-column>
      <el-table-column prop="OrderAmount" label="订单金额"></el-table-column>
      <el-table-column prop="CouponAmount" label="优惠金额"></el-table-column>
      <el-table-column prop="AccountPayAmount" label="余额支付"></el-table-column>
       <el-table-column prop="OtherPayAmount" label="在线支付"></el-table-column>        
      <el-table-column prop="PaymentAmount" label="实付"></el-table-column>
      <!-- <el-table-column prop="RefundAmount" label="退款"></el-table-column> -->
      <el-table-column prop="PayType" label="付款方式" :formatter="payTypeFormat"></el-table-column>
      <el-table-column prop="TradeNo" label="支付流水号">
        <template slot-scope="scope">
          <cutTip :text="scope.row.TradeNo"></cutTip>
        </template>
      </el-table-column>

    </el-table>
    <div class="block">
      <el-pagination
        v-if="retData.Data.length>0"
        @current-change="get"
        :current-page.sync="searchModel.PageIndex"
        :page-size="50"
        layout="total,prev, pager, next"
        :total="retData.TotalCount"
      ></el-pagination>
    </div>

      <el-dialog title="认领订单" :visible.sync="showDialog" width="300px">
      <el-form :model="takeModel" ref="inputForm" label-width="80px">
        <el-form-item prop="phone" label="手机号">
          <el-input v-model="takeModel.phone" size="small"></el-input>
        </el-form-item>
        <el-form-item prop="amount" label="订单金额">
          <el-input v-model="takeModel.amount" size="small" type="number"></el-input>
        </el-form-item>
      </el-form>
      <span slot="footer" class="dialog-footer">
        <el-button @click="resetForm('inputForm')">取 消</el-button>
        <el-button type="primary" @click="take()">确定</el-button>
      </span>
    </el-dialog>
  </div>
</template>
<script>
export default {
  name: "treeTable",
  components: {
    cutTip:()=>import("@/components/common/cutTip"),
    phoneHide: () => import("@/components/common/phonehide")
  },
  data() {
    return {
      loading: false,
      showDialog:false,
      types:[
       {text: '新开', value: '1'},
       {text: '批量新开', value: '2'}, 
       {text: '续费', value: '3'}, 
       {text: '批量续费', value: '4'}],
      retData: { TotalCount: 0, Data: [] },
      dateRange:[],
      products:[],
      searchModel: {
        PageIndex: 1,
        ProductId:null,
        keyWord: "",
        Status: 0,
        PayType: 0,
        OrderTypes:[],
        Btime: "",
        Etime: ""
      },
      takeModel:{
        phone:'',
        amount:''
      },
      types: [
        { text: "新开", value: 1 },
        { text: "批量新开", value: 2 },
        { text: "续费", value: 3 },
        { text: "批量续费", value: 4 },
        { text: "老账号认证", value: 100 },
        { text: "测试", value: 200 }
      ],
      typeFormat(row, column, cellValue, index){
        switch (cellValue) {
          case 1:
            return "新开";
          case 2:
            return "批量新开";
          case 3:
            return "续费";
          case 4:
            return "批量续费";        
        }
        return "";
       },
       payTypeFormat(row, column, cellValue, index){
        switch (cellValue) {
          case 10:
            return "余额";
          case 70:
            return "微信";
          case 100:
            return "支付宝";         
        }
        return "";
       }
    };
  },
  created() {
     this.$store.commit("setCurrentNav","订单管理>>销售订单")
    this.get();
    this.getProduct();
  },
  methods: {
    search(){
      this.searchModel.PageIndex=1;
      this.get();
    },
    get() {
       if (this.dateRange && this.dateRange.length == 2) {
        this.searchModel.Btime = this.dateRange[0];
        this.searchModel.Etime = this.dateRange[1];
      }
      this.$api.get("course/v1/order/SellerOrders", this.searchModel).then(res => {
        this.retData = res;
      });
    },
    getProduct() {
      this.loading = true;
      this.$api.get("course/v1/product/page", this.searchModel).then(res => {
        this.products = res.Data;
        this.loading = false;
      });
    },
    filterHandler(filters) {
      console.log(filters)
      var values=Object.values(filters);
      console.log(...values)
      values.forEach(m=>{
         this.searchModel.OrderTypes.push(...m)
      });     
      this.get(); 
    },
    resetForm(formName) {
      this.$refs[formName].resetFields();
      this.showDialog = false;    
    },
    take(){
       this.$api.get("course/v1/order/TakeOrder", this.takeModel).then(res => {
        this.resetForm('inputForm')
        this.get();
      });      
    },
    dataExport() {
      this.$api.getDownloadFile("/course/v1/order/ExportSellerOrders", this.searchModel);
    }
  }
};
</script>
<style scoped>
</style>
